## gofigure2 0.9.0

=== CMakeLists.txt ===
IF( COMMAND CMAKE_POLICY )
  CMAKE_POLICY( VERSION 2.6 )
  CMAKE_POLICY( SET CMP0005 OLD )
  CMAKE_POLICY( SET CMP0003 NEW )
ENDIF(COMMAND CMAKE_POLICY)

# On Visual Studio 8 MS deprecated C. This removes all 1.276E1265 security
# warnings. Copied from ITK CMakeLists.
IF( WIN32 )
  IF( NOT BORLAND )
    IF( NOT CYGWIN )
      IF( NOT MINGW )
          ADD_DEFINITIONS(
            -D_CRT_FAR_MAPPINGS_NO_DEPRECATE
            -D_CRT_IS_WCTYPE_NO_DEPRECATE
            -D_CRT_MANAGED_FP_NO_DEPRECATE
            -D_CRT_NONSTDC_NO_DEPRECATE
            -D_CRT_SECURE_NO_DEPRECATE
            -D_CRT_SECURE_NO_DEPRECATE_GLOBALS
            -D_CRT_SETERRORMODE_BEEP_SLEEP_NO_DEPRECATE
            -D_CRT_TIME_FUNCTIONS_NO_DEPRECATE
            -D_CRT_VCCLRIT_NO_DEPRECATE
            -D_SCL_SECURE_NO_DEPRECATE
            )
      ENDIF( NOT MINGW )
    ENDIF( NOT CYGWIN )
  ENDIF( NOT BORLAND )
ENDIF( WIN32 )

#-------------------------------------------------------------------------
# When making one release: update GOFIGURE2_*_VERSION,
# GOFIGURE2_WC_REVISION and the date of the release

SET( GOFIGURE2_MAJOR_VERSION "0" )
SET( GOFIGURE2_MINOR_VERSION "9" )
SET( GOFIGURE2_WC_REVISION "0" )

SET( DATE "12/07/2011" )

SET( GOFIGURE2_VERSION
  "${GOFIGURE2_MAJOR_VERSION}.${GOFIGURE2_MINOR_VERSION}.${GOFIGURE2_WC_REVISION}" )

SET( GOFIGURE2_LIB_VERSION
  "${GOFIGURE2_MAJOR_VERSION}.${GOFIGURE2_MINOR_VERSION}" )

MESSAGE( STATUS "GoFigure2 version ${GOFIGURE2_VERSION}" )


#---------------------------------------------------------------------------
# CONFIGURE CMAKE
#---------------------------------------------------------------------------

SET( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
  "${CMAKE_CURRENT_SOURCE_DIR}/CMake/"
  "${CMAKE_CURRENT_SOURCE_DIR}/CMake/SuperBuild/"
  )

IF( UNIX )
  SET (CACHE CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
ENDIF( UNIX )


#---------------------------------------------------------------------------
# SUPERBUILD - DISABLED BY DEFAULT
#---------------------------------------------------------------------------

OPTION( SUPERBUILD "Use SuperBuild" OFF )

IF( SUPERBUILD )

  CMAKE_MINIMUM_REQUIRED( VERSION 2.8.3 )

  PROJECT( MYSUPERPROJECT )
  INCLUDE( "${CMAKE_CURRENT_SOURCE_DIR}/CMake/SuperBuild/SuperBuild.cmake" )
  RETURN()

ELSE( SUPERBUILD )

  # CMake >= 2.8.2 MUST be installed (which is required by ITK)
  CMAKE_MINIMUM_REQUIRED( VERSION 2.8.2 )

  PROJECT( GOFIGURE2 )

  #-------------------------------------------------------------------------
  OPTION( OPENMP_SUPPORT "Enable OpenMP support if possible" ON )

  IF( OPENMP_SUPPORT )

    FIND_PACKAGE( OpenMP )

    IF( OPENMP_FOUND )
      MESSAGE( STATUS "OpenMP found" )

      ADD_DEFINITIONS( -DHAS_OPENMP )

      SET( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}" )
      SET( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}" )
    ELSE()
      MESSAGE( STATUS "OpenMP not found" )

      REMOVE_DEFINITIONS( -DHAS_OPENMP )
    ENDIF()

  ELSE()

      REMOVE_DEFINITIONS( -DHAS_OPENMP )

  ENDIF()

  #-----------------------------------------------------------------------
  # Export and Install configuration
  #
  # GOFIGURE2_INSTALL_BUNDLE_DIR       - bundle dir
  # GOFIGURE2_INSTALL_HEADER_DIR       - include dir (headers)
  # GOFIGURE2_INSTALL_BIN_DIR          - binary dir (executables)
  # GOFIGURE2_INSTALL_LIB_DIR          - library dir (libs)
  # GOFIGURE2_INSTALL_DOC_DIR          - documentation dir
  # GOFIGURE2_INSTALL_LICENSE_DIR      - licenses dir
  # GOFIGURE2_INSTALL_RESOURCE_DIR     - resources dir
  #-----------------------------------------------------------------------

  IF( NOT GOFIGURE2_INSTALL_BUNDLE_DIR )
    SET( GOFIGURE2_INSTALL_BUNDLE_DIR "." )
  ENDIF( NOT GOFIGURE2_INSTALL_BUNDLE_DIR )

  IF( NOT GOFIGURE2_INSTALL_BIN_DIR )
    SET( GOFIGURE2_INSTALL_BIN_DIR "bin" )
  ENDIF( NOT GOFIGURE2_INSTALL_BIN_DIR )

  IF( NOT GOFIGURE2_INSTALL_HEADER_DIR )
    SET( GOFIGURE2_INSTALL_HEADER_DIR "include/gofigure2/" )
  ENDIF( NOT GOFIGURE2_INSTALL_HEADER_DIR )

  IF( NOT GOFIGURE2_INSTALL_LIB_DIR )
    SET( GOFIGURE2_INSTALL_LIB_DIR "lib/gofigure2" )
  ENDIF( NOT GOFIGURE2_INSTALL_LIB_DIR )

  IF( NOT GOFIGURE2_INSTALL_DOC_DIR )
    SET( GOFIGURE2_INSTALL_DOC_DIR "share/doc/gofigure2" )
  ENDIF( NOT GOFIGURE2_INSTALL_DOC_DIR )

  IF( NOT GOFIGURE2_INSTALL_LICENSE_DIR )
    SET( GOFIGURE2_INSTALL_LICENSE_DIR "share/doc/gofigure2/Licenses" )
  ENDIF( NOT GOFIGURE2_INSTALL_LICENSE_DIR )

  IF( NOT GOFIGURE2_INSTALL_RESOURCE_DIR )
    SET( GOFIGURE2_INSTALL_RESOURCE_DIR "share/doc/gofigure2/Resources" )
  ENDIF( NOT GOFIGURE2_INSTALL_RESOURCE_DIR )
  
  #---------------------------------------------------------------------------
  # Define CMAKE_whatever_OUTPUT_DIRECTORY
  #---------------------------------------------------------------------------
  # all target executables will be
  # in ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
  SET( CMAKE_RUNTIME_OUTPUT_DIRECTORY
    ${GOFIGURE2_BINARY_DIR}/bin
  )

  # all target static libraries will be in ${CMAKE_ARCHIVE_OUTPUT_DIRECTORY}
  SET( CMAKE_ARCHIVE_OUTPUT_DIRECTORY
    ${GOFIGURE2_BINARY_DIR}/lib
  )

  IF( NOT APPLE )
    # all shared libraries will be in ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
    # Note that modules (plugins) are considered as shared libraries
    SET( CMAKE_LIBRARY_OUTPUT_DIRECTORY
    #  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/plugins
       ${GOFIGURE2_BINARY_DIR}/lib
    )
  ELSE()
    SET( CMAKE_LIBRARY_OUTPUT_DIRECTORY
      ${GOFIGURE2_BINARY_DIR}/bin/gofigure.app/Contents/MacOS/
      )
  ENDIF()

  SET( GOFIGURE2_LIBRARY_DIRS ${GOFIGURE2_BINARY_DIR}/lib )

  #---------------------------------------------------------------------------
  # Export files (body of emails, etc...)
  #---------------------------------------------------------------------------
  # define useful variables
  IF( WIN32 )
    SET( OS "Windows" )
  ELSE( WIN32 )
    IF ( APPLE )
      SET( OS "Mac OS X" )
    ELSE( APPLE )
      SET( OS "Linux" )
    ENDIF( APPLE )
  ENDIF( WIN32 )

  # Licences
  file(MAKE_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/Licenses)

  file(COPY        ${GOFIGURE2_SOURCE_DIR}/Licenses/
     DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/Licenses)

  # Resources
  file(MAKE_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/Resources)

  CONFIGURE_FILE( ${GOFIGURE2_SOURCE_DIR}/Resources/BugEntry.txt.in
    ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/Resources/BugEntry.txt
    @ONLY
    )

  #---------------------------------------------------------------------------
  # Define TESTING_DATA_PATH
  #---------------------------------------------------------------------------
  SET( TESTING_DATA_PATH
    ${GOFIGURE2_SOURCE_DIR}/Testing/Data
    CACHE PATH "Directory which contains data for testing."
  )

  #---------------------------------------------------------------------------
  # Handle Documentation
  #---------------------------------------------------------------------------
  OPTION( BUILD_DOCUMENTATION "Build Doxygen Documentation" OFF )

  IF( BUILD_DOCUMENTATION )
    INCLUDE( "${GOFIGURE2_SOURCE_DIR}/CMake/ConfigDoxygen.cmake" )
  ENDIF( BUILD_DOCUMENTATION )

  #---------------------------------------------------------------------------
  # Main GoFigure Settings
  #---------------------------------------------------------------------------

  #---------------------------------------------------------------------------
  # Everything depends on VTK first
  # that way we can get Qt info from VTK
  #### VTK ####

  INCLUDE( "${GOFIGURE2_SOURCE_DIR}/CMake/ConfigVTK.cmake" )

  #----------------------------------------------------------
  # Then find ITK
  #### ITK ####
  INCLUDE( "${GOFIGURE2_SOURCE_DIR}/CMake/ConfigITK.cmake" )

  #----------------------------------------------------------
  # Then find Boost
  #### BOOST ####
  INCLUDE( "${GOFIGURE2_SOURCE_DIR}/CMake/ConfigBoost.cmake" )

  #----------------------------------------------------------
  # Then find Qt.
  # Note that some command line tools will get compiled even without Qt
  #### Qt ####
  INCLUDE( "${GOFIGURE2_SOURCE_DIR}/CMake/ConfigQT.cmake" )

  #----------------------------------------------------------
  #
  SET( GOFIGURE2_EXTERNAL_SOURCE_DIR
    ${GOFIGURE2_SOURCE_DIR}/Code/ExternalCode )
  SET( GOFIGURE2_EXTERNAL_BINARY_DIR
    ${GOFIGURE2_BINARY_DIR}/Code/ExternalCode )

  SET( MEGAVTK2_SOURCE_DIR ${GOFIGURE2_EXTERNAL_SOURCE_DIR}/MegaVTK )
  SET( MEGAVTK2_BINARY_DIR ${GOFIGURE2_EXTERNAL_BINARY_DIR}/MegaVTK )

  LINK_DIRECTORIES(
    ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
    ${CMAKE_ARCHIVE_OUTPUT_DIRECTORY}
    ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
    )

  INCLUDE_DIRECTORIES( BEFORE
    ${QT_INCLUDES}
    ${GOFIGURE2_SOURCE_DIR}/Code/
    ${GOFIGURE2_BINARY_DIR}/Code/
    ${GOFIGURE2_SOURCE_DIR}/Code/IO/
    ${GOFIGURE2_BINARY_DIR}/Code/IO/
    ${GOFIGURE2_SOURCE_DIR}/Code/IO/GoDBRow/
    ${GOFIGURE2_BINARY_DIR}/Code/IO/GoDBRow/
    ${GOFIGURE2_SOURCE_DIR}/Code/IO/GoImage/
    ${GOFIGURE2_BINARY_DIR}/Code/IO/GoImage/
    ${GOFIGURE2_SOURCE_DIR}/Code/Filters/
    ${GOFIGURE2_BINARY_DIR}/Code/Filters/
    ${GOFIGURE2_SOURCE_DIR}/Code/Filters/Contour/
    ${GOFIGURE2_BINARY_DIR}/Code/Filters/Contour/
    ${GOFIGURE2_SOURCE_DIR}/Code/Filters/Mesh/
    ${GOFIGURE2_BINARY_DIR}/Code/Filters/Mesh/
    ${GOFIGURE2_SOURCE_DIR}/Code/Filters/Mesh/Attributes/
    ${GOFIGURE2_BINARY_DIR}/Code/Filters/Mesh/Attributes/
    ${GOFIGURE2_SOURCE_DIR}/Code/Filters/Mesh/Split/
    ${GOFIGURE2_BINARY_DIR}/Code/Filters/Mesh/Split/
    ${GOFIGURE2_SOURCE_DIR}/Code/Filters/Mesh/Merge/
    ${GOFIGURE2_BINARY_DIR}/Code/Filters/Mesh/Merge/
    ${GOFIGURE2_SOURCE_DIR}/Code/GUI/
    ${GOFIGURE2_BINARY_DIR}/Code/GUI/
    ${GOFIGURE2_SOURCE_DIR}/Code/GUI/lib/
    ${GOFIGURE2_BINARY_DIR}/Code/GUI/lib/
    ${GOFIGURE2_BINARY_DIR}/Code/GUI/lib/Resources/
    ${GOFIGURE2_SOURCE_DIR}/Code/GUI/lib/DBManager/
    ${GOFIGURE2_SOURCE_DIR}/Code/GUI/lib/DBManager/
    ${GOFIGURE2_BINARY_DIR}/Code/GUI/lib/SynchronizedViews/
    ${GOFIGURE2_BINARY_DIR}/Code/GUI/lib/SynchronizedViews/
    ${GOFIGURE2_SOURCE_DIR}/Code/GUI/lib/VisualizationTraceContainers/
    ${GOFIGURE2_BINARY_DIR}/Code/GUI/lib/VisualizationTraceContainers/
    ${GOFIGURE2_SOURCE_DIR}/Code/GUI/lib/Video/
    ${GOFIGURE2_BINARY_DIR}/Code/GUI/lib/Video/
    ${GOFIGURE2_SOURCE_DIR}/Code/GUI/lib/Wizard/
    ${GOFIGURE2_BINARY_DIR}/Code/GUI/lib/Wizard/
    ${GOFIGURE2_SOURCE_DIR}/Code/GUI/lib/TraceEditing/
    ${GOFIGURE2_BINARY_DIR}/Code/GUI/lib/TraceEditing/
    ${GOFIGURE2_SOURCE_DIR}/Code/GUI/lib/TransferFunctionEditor/
    ${GOFIGURE2_BINARY_DIR}/Code/GUI/lib/TransferFunctionEditor/
    ${GOFIGURE2_SOURCE_DIR}/Code/GUI/lib/LineageViewer/
    ${GOFIGURE2_BINARY_DIR}/Code/GUI/lib/LineageViewer/
    ${GOFIGURE2_SOURCE_DIR}/Interfaces/
    ${GOFIGURE2_BINARY_DIR}/Interfaces/
    ${GOFIGURE2_SOURCE_DIR}/Code/GUI/src/
    ${GOFIGURE2_BINARY_DIR}/Code/GUI/src/
    ${MEGAVTK2_SOURCE_DIR}
    ${MEGAVTK2_BINARY_DIR}
    ${MEGAVTK2_SOURCE_DIR}/vtkItk
    ${MEGAVTK2_BINARY_DIR}/vtkItk
    ${MEGAVTK2_SOURCE_DIR}/vtkRenderingAddOn
    ${MEGAVTK2_BINARY_DIR}/vtkRenderingAddOn
    ${GOFIGURE2_EXTERNAL_SOURCE_DIR}/vtkLSM
    ${GOFIGURE2_EXTERNAL_BINARY_DIR}/vtkLSM
    ${GOFIGURE2_EXTERNAL_BINARY_DIR}/itkQt
    ${GOFIGURE2_EXTERNAL_SOURCE_DIR}/itkQt
    ${GOFIGURE2_EXTERNAL_SOURCE_DIR}/PoissonReconstruction
    ${GOFIGURE2_EXTERNAL_BINARY_DIR}/PoissonReconstruction
    ${GOFIGURE2_EXTERNAL_SOURCE_DIR}/ctk
    ${GOFIGURE2_EXTERNAL_BINARY_DIR}/ctk
    ${GOFIGURE2_SOURCE_DIR}/Main
    ${GOFIGURE2_BINARY_DIR}/Main
  )

  #---------------------------------------------------------------------
  #---------------------------------------------------------------------

  SET( QGoResourceFile ${GOFIGURE2_SOURCE_DIR}/Resources/axes.qrc )

  SET( QGoGUIINTERFACES_HDRS
    ${GOFIGURE2_SOURCE_DIR}/Interfaces/QGoPlugin.h
    ${GOFIGURE2_SOURCE_DIR}/Interfaces/QGoImageFilterPluginBase.h
  )
  SET( QGoGUIINTERFACES_SRC

=== Code/CMakeLists.txt ===
# add subdirectories
ADD_SUBDIRECTORY( ExternalCode )
ADD_SUBDIRECTORY( Database )
ADD_SUBDIRECTORY( IO )
ADD_SUBDIRECTORY( Filters )
ADD_SUBDIRECTORY( GUI )


FILE( GLOB __source_file_h "${CMAKE_CURRENT_SOURCE_DIR}/*.h" )

INSTALL( FILES ${__source_file_h}
  DESTINATION ${GOFIGURE2_INSTALL_HEADER_DIR}
  COMPONENT Development
)

=== Documentation/CMakeLists.txt ===
ADD_SUBDIRECTORY( Doxygen )

=== Examples/CMakeLists.txt ===
ADD_SUBDIRECTORY( ExternalCode )
ADD_SUBDIRECTORY( Filters )
ADD_SUBDIRECTORY( IO )
ADD_SUBDIRECTORY( GUI )

=== KWStyle/CMakeLists.txt ===
#-----------------------------------------------------------------------------
# uses KWStyle for checking the coding style
INCLUDE(KWStyle.cmake)


IF(UNIX)
  CONFIGURE_FILE(${GOFIGURE2_SOURCE_DIR}/KWStyle/doAllStyle.csh.in
                 ${GOFIGURE2_BINARY_DIR}/doAllStyle.csh
                 @ONLY IMMEDIATE)
  EXEC_PROGRAM(chmod ARGS 755 \"${GOFIGURE2_BINARY_DIR}/doAllStyle.csh\"
                     OUTPUT_VARIABLE ITK_EXEC_PLEASE_BE_QUIET)
ENDIF(UNIX)

=== Main/CMakeLists.txt ===
CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/gofigure.cxx.in
  ${CMAKE_CURRENT_BINARY_DIR}/gofigure.cxx @ONLY IMMEDIATE
)

SET( QGoMainWindow_UI
  go.ui
)

SET( QGoGUISRC_HDRS
  QGoTabManager.h
  QGoMainWindow.h
  QGoPluginManager.h
  ${QGoGUIINTERFACES_HDRS}
)

SET( GOFIGURE_MAIN
  ${CMAKE_CURRENT_BINARY_DIR}/gofigure.cxx
)

SET( GOFIGURE_APPLICATION_SOURCE_LIST
  QGoTabManager.cxx
  QGoMainWindow.cxx
  QGoPluginManager.cxx
  )

IF( BUILD_COMPARETOOL )
  SET( QGoGUISRC_HDRS
    ${QGoGUISRC_HDRS}
    QGoSynchronizedViewMainWindow.h
  )

  SET( GOFIGURE_APPLICATION_SOURCE_LIST
    ${GOFIGURE_APPLICATION_SOURCE_LIST}
    ${QGoSynchronizedViewMainWindow.cxx}
  )
ENDIF( BUILD_COMPARETOOL )

INCLUDE_DIRECTORIES( ${GOFIGURE2_BINARY_DIR}/Main/  )

QT4_WRAP_UI( QGoMainWindow_UI_H ${QGoMainWindow_UI} )

QT4_WRAP_CPP( QGoGUISRC_MOC ${QGoGUISRC_HDRS} )

SET_SOURCE_FILES_PROPERTIES(
  ${GOFIGURE_APPLICATION_SOURCE_LIST}
  PROPERTIES
  OBJECT_DEPENDS "${QGoMainWindow_UI_H}"
  )

SET_SOURCE_FILES_PROPERTIES(
  ${QGoGUISRC_MOC}
  PROPERTIES
  OBJECT_DEPENDS "${QGoMainWindow_UI_H}"
  )

QT4_ADD_RESOURCES( QGoMainWindow_QRC
  ${QGoResourceFile}
  )

SET( QGoGUISRC_SRC
  ${QGoGUISRC_CXX}
  ${QGoGUISRC_MOC}
)

set( qt_menu_nib_sources )

IF( APPLE )

  IF( QT_MAC_USE_COCOA )
    GET_FILENAME_COMPONENT( qt_menu_nib
     "@QT_QTGUI_LIBRARY_RELEASE@/Resources/qt_menu.nib"
      REALPATH )

    set( qt_menu_nib_sources
      "${qt_menu_nib}/classes.nib"
      "${qt_menu_nib}/info.nib"
      "${qt_menu_nib}/keyedobjects.nib"
      )

    SET_SOURCE_FILES_PROPERTIES(
      ${qt_menu_nib_sources}
      PROPERTIES
      MACOSX_PACKAGE_LOCATION Resources/qt_menu.nib
      )
  ENDIF( QT_MAC_USE_COCOA )

  SET( MACOSX_BUNDLE_ICON_FILE
    ${GOFIGURE2_SOURCE_DIR}/Resources/myapp.icns
    )

  SET_SOURCE_FILES_PROPERTIES(
    ${MACOSX_BUNDLE_ICON_FILE}
    PROPERTIES
    MACOSX_PACKAGE_LOCATION Resources
    )

  SET( GOFIGURE_APPLICATION_SOURCE_LIST
    ${GOFIGURE_APPLICATION_SOURCE_LIST}
    ${MACOSX_BUNDLE_ICON_FILE}
    )

  SET( MACOSX_BUNDLE_SHORT_VERSION_STRING
    ${GOFIGURE2_VERSION}
    )

  SET( MACOSX_BUNDLE_VERSION
    ${GOFIGURE2_VERSION}
    )

  SET( MACOSX_BUNDLE_LONG_VERSION_STRING
    Version ${GOFIGURE2_VERSION}
    )

  SET( GOFIGURE2_INSTALL_LICENSE_DIR    ${plugin_dest_dir}/Licenses   )
  SET( GOFIGURE2_INSTALL_RESOURCE_DIR  ${plugin_dest_dir}/Resources  )

ENDIF( APPLE )

IF( WIN32 )
  IF( MINGW )
    ADD_CUSTOM_COMMAND( OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/myapp.o
      COMMAND windres.exe -I${CMAKE_CURRENT_SOURCE_DIR}
        -i ${GOFIGURE2_SOURCE_DIR}/Resources/myapp.rc
        -o ${CMAKE_CURRENT_BINARY_DIR}/myapp.o
        )

    SET( ${GOFIGURE_APPLICATION_SOURCE_LIST}
      ${GOFIGURE_APPLICATION_SOURCE_LIST}
      ${CMAKE_CURRENT_BINARY_DIR}/myapp.o
      )
  ELSE( MINGW )
    SET( GOFIGURE_APPLICATION_SOURCE_LIST
      ${GOFIGURE_APPLICATION_SOURCE_LIST}
      ${GOFIGURE2_SOURCE_DIR}/Resources/myapp.rc
      )
  ENDIF( MINGW )

  #-------------------------------------------------------------------------
  # This sets the windows build that will need the special winmain@16 call.
  # Qt provides this for us in the qtmain.lib file. Using this cmake code
  # will ensure we have it linked into our build. Not needed on
  # Unix/OS X/Linux which is why we have the IF(WIN32) conditional.
  SET( QT_USE_QTMAIN TRUE )

ENDIF( WIN32 )

# --------
# gofigure
ADD_EXECUTABLE( gofigure
  MACOSX_BUNDLE
  ${GOFIGURE_MAIN}
  ${GOFIGURE_APPLICATION_SOURCE_LIST}
  ${QGoGUIINTERFACES_SRC}
  ${QGoGUISRC_MOC}
  ${QGoMainWindow_QRC}
  ${qt_menu_nib_sources}
)

TARGET_LINK_LIBRARIES( gofigure
  QGoGui
  QGoIO
  itkQt
  ${Boost_LIBRARIES}
 )

IF( BUILD_COMPARETOOL )
  # comparegui

  ADD_EXECUTABLE( comparegui
    comparegui.cxx
    ${GOFIGURE_APPLICATION_SOURCE_LIST}
    ${QGoGUIINTERFACES_SRC}
    ${QGoGUISRC_MOC}
    ${QGoMainWindow_QRC}
    ${qt_menu_nib_sources}
  )

  TARGET_LINK_LIBRARIES( comparegui
    QGoGui
    QGoIO
    itkQt
  )
ENDIF( BUILD_COMPARETOOL )


#---------------------------------------------------------------------------
# Now the installation stuff below
#---------------------------------------------------------------------------
SET( plugin_dest_dir ${GOFIGURE2_INSTALL_BIN_DIR} )
SET( qtconf_dest_dir ${GOFIGURE2_INSTALL_BIN_DIR} )

IF( APPLE )
  SET( plugin_dest_dir gofigure.app/Contents/MacOS )
  SET( qtconf_dest_dir gofigure.app/Contents/Resources )
  SET( APPS
    "\${CMAKE_INSTALL_PREFIX}/gofigure.app" )
#    "\${CMAKE_INSTALL_PREFIX}/${GOFIGURE2_INSTALL_BUNDLE_DIR}/gofigure.app" )
ENDIF( APPLE )

IF( WIN32 )
  SET( APPS
    "\${CMAKE_INSTALL_PREFIX}/${GOFIGURE2_INSTALL_BIN_DIR}/gofigure.exe" )
ENDIF(WIN32)

IF( UNIX AND NOT APPLE )
  SET( APPS
    "\${CMAKE_INSTALL_PREFIX}/${GOFIGURE2_INSTALL_BIN_DIR}/gofigure" )

  IF( NOT DESKTOP_ENTRY )
    SET( DESKTOP_ENTRY gofigure2.desktop )
  ENDIF( NOT DESKTOP_ENTRY )

  CONFIGURE_FILE( ${GOFIGURE2_SOURCE_DIR}/Main/gf2-desktop.sh.in
    ${GOFIGURE2_BINARY_DIR}/Main/gf2-desktop.sh @ONLY IMMEDIATE
  )

  ADD_CUSTOM_COMMAND( OUTPUT ${DESKTOP_ENTRY}
    COMMAND touch ${DESKTOP_ENTRY}
    COMMAND sh ${GOFIGURE2_BINARY_DIR}/Main/gf2-desktop.sh
      ${CMAKE_INSTALL_PREFIX} >${DESKTOP_ENTRY}
    DEPENDS ${GOFIGURE2_BINARY_DIR}/Main/gf2-desktop.sh
    COMMENT "Generating desktop entry file"
  )

  ADD_CUSTOM_TARGET( DESKTOP_ENTRY_FILE ALL
    DEPENDS ${DESKTOP_ENTRY}
  )

  SET( GOFIGURE2_ICON ${GOFIGURE2_SOURCE_DIR}/Resources/fig/Myapp2.png )

  INSTALL( FILES ${GOFIGURE2_ICON}
    DESTINATION share/gofigure2/icons COMPONENT Runtime )
ENDIF( UNIX AND NOT APPLE )

# MESSAGE( ${APPS} )

#---------------------------------------------------------------------------
# Install gofigure, on Apple, the bundle is at the root of the
# install tree, and on other platforms it'll go into the bin directory.

INSTALL( TARGETS gofigure
  ARCHIVE DESTINATION ${GOFIGURE2_INSTALL_LIB_DIR} COMPONENT Libraries
  LIBRARY DESTINATION ${GOFIGURE2_INSTALL_LIB_DIR} COMPONENT Libraries
  RUNTIME DESTINATION ${GOFIGURE2_INSTALL_BIN_DIR} COMPONENT Runtime
  BUNDLE  DESTINATION ${GOFIGURE2_INSTALL_BUNDLE_DIR} COMPONENT Runtime
  )

#---------------------------------------------------------------------------

IF( WIN32 OR APPLE )
  SET( USE_BUNDLE_UTILITIES TRUE )
ELSE()
  OPTION( INSTALLED_3RD_PART "Are Qt, VTK, ITK... installed?" TRUE )
  SET( USE_BUNDLE_UTILITIES FALSE )
ENDIF()

IF( USE_BUNDLE_UTILITIES )
  #---------------------------------------------------------------------------
  # Use BundleUtilities to get all other dependencies for the application to
  # work. It takes a bundle or executable along with possible plugins and
  # inspects it for dependencies.  If they are not system dependencies,
  # they are copied.

  # directories to look for dependencies
  SET( DIRS
#    ${QT_LIBRARY_DIR}
#    ${QT_PLUGINS_DIR}
#    ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
#    ${CMAKE_ARCHIVE_OUTPUT_DIRECTORY}
#    ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
#    ${ITK_LIBRARY_DIRS}
#    ${VTK_LIBRARY_DIRS}
#    ${FFMPEG_LIBRARY_DIRS}
    " "
  )

  # Now the work of copying dependencies into the bundle/package
  # The quotes are escaped and variables to use at install time have their $ i# escaped
  # An alternative is the do a configure_file() on a script and use
  # install(SCRIPT  ...).
  # Note that the image plugins depend on QtSvg and QtXml, and it got those
  # copied over.
  INSTALL( CODE "
    file( GLOB_RECURSE QTPLUGINS
      \"\${CMAKE_INSTALL_PREFIX}/${plugin_dest_dir}/plugins/*${CMAKE_SHARED_LIBRARY_SUFFIX}\" )
      include( BundleUtilities )
      fixup_bundle(\"${APPS}\" \"\${QTPLUGINS}\" \"${DIRS}\")
    "
    COMPONENT Runtime
    )

ENDIF( USE_BUNDLE_UTILITIES )

IF( APPLE )
  #---------------------------------------------------------------------------
  # install a qt.conf file
  # this inserts some cmake code into the install script to write the file
  INSTALL( CODE "
    file( WRITE \"\${CMAKE_INSTALL_PREFIX}/${GOFIGURE2_INSTALL_BUNDLE_DIR}/${qtconf_dest_dir}/qt.conf\" \"\")
    " COMPONENT Runtime
    )
ENDIF( APPLE )

#-----------------------------------------------------
# Here Let's take care of License and Resoources files
FILE( GLOB
  GOFIGURE2_LICENSE_FILES
  "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/Licenses/*.txt"
  )

FILE( GLOB
  GOFIGURE2_RESOURCES_FILE
  "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/Resources/*.txt"
  )
  
# licence files
INSTALL( FILES ${GOFIGURE2_LICENSE_FILES}
  DESTINATION ${GOFIGURE2_INSTALL_LICENSE_DIR}
  COMPONENT Runtime
)

# resources files
INSTALL( FILES ${GOFIGURE2_RESOURCES_FILE}
  DESTINATION ${GOFIGURE2_INSTALL_RESOURCE_DIR}
  COMPONENT Runtime
)

FILE( GLOB __source_file_h "${CMAKE_CURRENT_SOURCE_DIR}/*.h" )

INSTALL( FILES ${__source_file_h} ${QGoMainWindow_UI_H}
  DESTINATION ${GOFIGURE2_INSTALL_HEADER_DIR}
  COMPONENT Development
)

=== Plugins/CMakeLists.txt ===
ADD_SUBDIRECTORY( ImageMedianPlugin )

=== Testing/CMakeLists.txt ===
ADD_SUBDIRECTORY( Sikuli )

=== Code/ExternalCode/CMakeLists.txt ===
SUBDIRS(
  itkQt
  MegaVTK
  vtkLSM
  PoissonReconstruction
  ctk
)

=== Code/Filters/CMakeLists.txt ===
# for the installation
FILE( GLOB __source_file_h "${CMAKE_CURRENT_SOURCE_DIR}/*.h" )
FILE( GLOB __source_file_txx "${CMAKE_CURRENT_SOURCE_DIR}/*.txx" )

FILE( GLOB __contour_source_file_h "${CMAKE_CURRENT_SOURCE_DIR}/Contour/*.h" )
FILE( GLOB __contour_source_file_txx "${CMAKE_CURRENT_SOURCE_DIR}/Contour/*.txx" )

FILE( GLOB __mesh_source_file_h "${CMAKE_CURRENT_SOURCE_DIR}/Mesh/*.h" )
FILE( GLOB __mesh_source_file_txx "${CMAKE_CURRENT_SOURCE_DIR}/Mesh/*.txx" )

FILE( GLOB __mesh_att_source_file_h "${CMAKE_CURRENT_SOURCE_DIR}/Mesh/Attributes/*.h" )
FILE( GLOB __mesh_att_source_file_txx "${CMAKE_CURRENT_SOURCE_DIR}/Mesh/Attributes/*.txx" )

FILE( GLOB __mesh_split_source_file_h "${CMAKE_CURRENT_SOURCE_DIR}/Mesh/Split/*.h" )
FILE( GLOB __mesh_split_source_file_txx "${CMAKE_CURRENT_SOURCE_DIR}/Mesh/Split/*.txx" )

FILE( GLOB __mesh_merge_source_file_h "${CMAKE_CURRENT_SOURCE_DIR}/Mesh/Merge/*.h" )
FILE( GLOB __mesh_merge_source_file_txx "${CMAKE_CURRENT_SOURCE_DIR}/Mesh/Merge/*.txx" )

INSTALL( FILES ${__source_file_h} ${__source_file_txx}
  ${__contour_source_file_h} ${__contour_source_file_txx}
  ${__mesh_source_file_h} ${__mesh_source_file_txx}
  ${__mesh_att_source_file_h} ${__mesh_att_source_file_txx}
  ${__mesh_split_source_file_h} ${__mesh_split_source_file_txx}
  ${__mesh_merge_source_file_h} ${__mesh_merge_source_file_txx}
  DESTINATION ${GOFIGURE2_INSTALL_HEADER_DIR}
  COMPONENT Development
)

=== Code/GUI/CMakeLists.txt ===
ADD_SUBDIRECTORY( lib )

=== Code/IO/CMakeLists.txt ===
IF( WIN32 )
  IF( NOT CYGWIN )
    IF( NOT MINGW )
      IF( BUILD_SHARED_LIBS )
        ADD_DEFINITIONS( -DQGoIO_EXPORT )
      ENDIF( BUILD_SHARED_LIBS )
    ENDIF( NOT MINGW )
  ENDIF( NOT CYGWIN )
ENDIF( WIN32 )

CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/QGoIOConfigure.h.in
 ${CMAKE_CURRENT_BINARY_DIR}/QGoIOConfigure.h
 @ONLY IMMEDIATE
)

SET( QGOIO_SRC
  TraceStructure.cxx
  ContourMeshStructure.cxx
  TrackStructure.cxx
  LineageStructure.cxx
  CreateDataBaseHelper.cxx
  GoDBTableWidgetContainer.cxx
  GoDBTWContainerForContourMesh.cxx
  GoDBTWContainerForTrackLineage.cxx
  GoDBTWContainerForMesh.cxx
  GoDBTWContainerForTrack.cxx
  GoDBTWContainerForLineage.cxx
  GoDBExport.cxx
  GoDBImport.cxx
  GoDBCollectionOfTraces.cxx
  
  # GoDB*Row
  GoDBRow/GoDBAuthorRow.cxx
  GoDBRow/GoDBChannelRow.cxx
  GoDBRow/GoDBColorRow.cxx
  GoDBRow/GoDBContourRow.cxx
  GoDBRow/GoDBCoordinateRow.cxx
  GoDBRow/GoDBImageRow.cxx
  GoDBRow/GoDBImgSessionRow.cxx
  GoDBRow/GoDBMeshRow.cxx
  GoDBRow/GoDBProjectRow.cxx
  GoDBRow/GoDBTraceRow.cxx
  GoDBRow/GoDBRow.cxx
  GoDBRow/GoDBTrackRow.cxx
  GoDBRow/GoDBTrackFamilyRow.cxx
  GoDBRow/GoDBLineageRow.cxx
  GoDBRow/GoDBNameDescRow.cxx
  GoDBRow/GoDBBookmarkRow.cxx
  GoDBRow/GoDBCellTypeRow.cxx
  GoDBRow/GoDBSubCellTypeRow.cxx
  GoDBRow/GoDBIntensityRow.cxx

  # Mega related files
  GoImage/GoImageProcessor.cxx
  GoImage/GoMegaImageProcessor.cxx
  GoImage/GoLSMImageProcessor.cxx
  itkMegaCaptureImport.cxx
  itkMegaCaptureReader.cxx
  MegaCaptureHeaderReader.cxx

  QueryDataBaseHelper.cxx
  SelectQueryDatabaseHelper.cxx
  QueryBuilderHelper.cxx
  # itkLsm3DSerieImport.cxx

  GoFigureFileInfoMultiIndexContainerHelper.cxx
  vtkPolyDataMySQLContourReader.cxx
  vtkPolyDataMySQLMeshReader.cxx
  vtkPolyDataMySQLTrackReader.cxx
  vtkPolyDataMySQLContourWriter.cxx
  vtkPolyDataMySQLMeshWriter.cxx
  vtkPolyDataMySQLTrackWriter.cxx
  LSMToMegaCapture.cxx
#  MeshTextFileImport.cxx
#  TrackTextFileImport.cxx
)

SET_SOURCE_FILES_PROPERTIES(
  GoDBRow/GoDBRow.cxx
  GoDBRow/GoDBTraceRow.cxx
  GoDBTableWidgetContainer.cxx
  GoDBRow/GoDBNameDescRow.cxx
  ABSTRACT
  )

ADD_LIBRARY( QGoIO
  ${QGOIO_SRC}
)

ADD_DEPENDENCIES( QGoIO vtkLSMReader )

TARGET_LINK_LIBRARIES( QGoIO
  ${QT_LIBRARIES}
  QGoIO
  vtkHybrid
  vtkIO
  vtkImaging
  vtkLSMReader
  ${ITK_LIBRARIES}
)

SET_TARGET_PROPERTIES( QGoIO PROPERTIES VERSION ${GOFIGURE2_LIB_VERSION} SOVERSION ${GOFIGURE2_LIB_VERSION} )

# Runtime
INSTALL( TARGETS QGoIO
  EXPORT GoFigure2Targets
  RUNTIME DESTINATION ${GOFIGURE2_INSTALL_BIN_DIR} COMPONENT Runtime
  ARCHIVE DESTINATION ${GOFIGURE2_INSTALL_LIB_DIR} COMPONENT Libraries
  LIBRARY DESTINATION ${GOFIGURE2_INSTALL_LIB_DIR} NAMELINK_SKIP COMPONENT Libraries
  )

# Development
INSTALL( TARGETS QGoIO
  EXPORT GoFigure2Targets
  RUNTIME DESTINATION ${GOFIGURE2_INSTALL_BIN_DIR} COMPONENT Runtime
  ARCHIVE DESTINATION ${GOFIGURE2_INSTALL_LIB_DIR} COMPONENT Libraries
  LIBRARY DESTINATION ${GOFIGURE2_INSTALL_LIB_DIR} COMPONENT Libraries NAMELINK_ONLY
  )

FILE( GLOB __source_file_h "${CMAKE_CURRENT_SOURCE_DIR}/*.h" )
FILE( GLOB __source_file_txx "${CMAKE_CURRENT_SOURCE_DIR}/*.txx" )

FILE( GLOB __binary_file_h "${CMAKE_CURRENT_BINARY_DIR}/*.h" )
FILE( GLOB __binary_file_txx "${CMAKE_CURRENT_BINARY_DIR}/*.txx" )

INSTALL( FILES ${__source_file_h} ${__source_file_txx}
    ${__binary_file_h} ${__binary_file_txx}
  DESTINATION ${GOFIGURE2_INSTALL_HEADER_DIR}
  COMPONENT Development
)

=== debian/changelog ===
gofigure2 (0.9.0-3) unstable; urgency=low

  * Set CMAKE_BUILD_TYPE to None
  * Bump Std-Vers to 3.9.5, no changes needed

 -- Mathieu Malaterre <malat@debian.org>  Fri, 13 Dec 2013 09:13:41 +0100

gofigure2 (0.9.0-2) unstable; urgency=low

  * Remove explicit B-D to libgdcm since not needed anymore
  * Remove DMUA flag, use my @d.o alias
  * Bump Std-Vers to 3.9.4, no changes needed
  * Fix building against newer VTK:
    - debian/patches/missingx11link.patch
  * Use hardening flags thanks to dh/9
  * Fix lintian about d/copyright empty lines
  * Add a gofigure2-doc package for documentation

 -- Mathieu Malaterre <malat@debian.org>  Fri, 24 May 2013 16:31:50 +0200

gofigure2 (0.9.0-1) unstable; urgency=low

  * New upstream
   - Many actions are parallelized with Open MP

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Sun, 11 Dec 2011 16:38:51 +0100

=== debian/control ===
Source: gofigure2
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <malat@debian.org>,
 Andreas Tille <tille@debian.org>
Build-Depends: debhelper (>= 9), cmake (>= 2.8.2), libboost-all-dev, libqt4-dev,
  libinsighttoolkit3-dev (>= 3.20), libvtk5-qt4-dev (>= 5.6), libfftw3-dev,
  libqtwebkit-dev | libqt4-dev (<< 4.7)
Build-Depends-Indep: qt4-doc-html, doxygen (>= 1.7.4) , graphviz, vtk-doc
Standards-Version: 3.9.5
Homepage: http://gofigure2.sourceforge.net
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/gofigure2/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/gofigure2/trunk/

Package: gofigure2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: mysql-server
Description: Tool for visualizing, processing and analysing of bioimages
 Main objectives of GoFigure2 are to provide
  * interaction/visualization/navigation into 4D multichannels bio-images;
  * save/retrieve information related to the imaging process, analysis results;
  * extracting objects from bio-images (e.g. nucleii, cell-membranes...);
  * tracking sub-cellular structure, cells;
  * detecting and tracking cell-division through time;
  * generating and visualizing cell-lineage. 

Package: libgofigure0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Tool for visualizing, processing and analysing of bioimages
 Main objectives of GoFigure2 are to provide
  * interaction/visualization/navigation into 4D multichannels bio-images;
  * save/retrieve information related to the imaging process, analysis results;
  * extracting objects from bio-images (e.g. nucleii, cell-membranes...);
  * tracking sub-cellular structure, cells;
  * detecting and tracking cell-division through time;
  * generating and visualizing cell-lineage. 
 .
 The runtime libraries

Package: libgofigure-dev
Section: libdevel
Architecture: any
Depends: libgofigure0 (= ${binary:Version}), ${misc:Depends}
Description: Tool for visualizing, processing and analysing of bioimages
 Main objectives of GoFigure2 are to provide
  * interaction/visualization/navigation into 4D multichannels bio-images;
  * save/retrieve information related to the imaging process, analysis results;
  * extracting objects from bio-images (e.g. nucleii, cell-membranes...);
  * tracking sub-cellular structure, cells;
  * detecting and tracking cell-division through time;
  * generating and visualizing cell-lineage. 
 .
 The development libraries

Package: gofigure2-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, vtk-doc, doc-base
Description: Tool for visualizing, processing and analysing of bioimages - doc
 Main objectives of GoFigure2 are to provide
  * interaction/visualization/navigation into 4D multichannels bio-images;
  * save/retrieve information related to the imaging process, analysis results;
  * extracting objects from bio-images (e.g. nucleii, cell-membranes...);
  * tracking sub-cellular structure, cells;
  * detecting and tracking cell-division through time;
  * generating and visualizing cell-lineage. 
 .
 This is the documentation for gofigure2

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# deduce documentation option (build-indep target)
ifeq "" "$(filter %-doc,$(shell dh_listpackages))"
  BUILDDOC=OFF
else
  BUILDDOC=ON
endif

CMAKE_EXTRA_FLAGS = \
  -DCMAKE_INSTALL_PREFIX:PATH=/usr \
  -DCMAKE_BUILD_TYPE:STRING=None \
  -DCMAKE_SKIP_RPATH:BOOL=OFF \
  -DBUILD_SHARED_LIBS:BOOL=ON \
	-DGOFIGURE2_INSTALL_LIB_DIR:STRING=lib/$(DEB_HOST_MULTIARCH) \
	-DBUILD_TESTING:BOOL=ON \
	-DBUILD_DOCUMENTATION:BOOL=$(BUILDDOC) \
	-DBUILD_PLUGINS:BOOL=ON \
	-DENABLE_VIDEO_RECORD_FFMPEG:BOOL=ON \
	-DBUILD_COMPARETOOL:BOOL=ON \
	-DSUPERBUILD:BOOL=OFF \
	-DLINK_EXTERNAL_DOC:BOOL=ON \
	-DDOXYGEN_NIGHTLY_LINK:BOOL=OFF \
	-DQT_DOC_DIR=/usr/share/qt4/doc/

%:
	dh $@ --parallel --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

# Let's be smart with building doc
override_dh_auto_build-indep:
	$(MAKE) -C build doc
	rm build/Documentation/html/jquery.js

# No tests needed for docs
override_dh_auto_test-indep:

override_dh_install-arch:
	dh_install --list-missing

pkg_doc=gofigure2-doc

override_dh_installdocs:
	dh_installdocs -p$(pkg_doc) build/Documentation/html
	dh_installdocs

debian/gofigure.1: debian/gofigure.1.in
	help2man --include=debian/gofigure.1.in \
		--output=debian/gofigure.1 --no-info gofigure

VER_FULL = $(shell dpkg-parsechangelog | grep '^Version' | cut -d' ' -f2 | cut -f1 -d-)
UPSTREAM_SRC = GoFigure2-v$(VER_FULL).tar.gz
DEBIAN_SRC_DIR = GoFigure2-v$(VER_FULL)
DEBIAN_SRC_TAR = gofigure2_$(VER_FULL).orig.tar.gz

$(UPSTREAM_SRC):
	wget http://voxel.dl.sourceforge.net/sourceforge/gofigure2/$@

get-orig-source: $(UPSTREAM_SRC)
	#uscan --verbose --force-download --repack --rename
	tar xzf $(UPSTREAM_SRC)
	# save some disk space, removing test data:
	rm -rf $(DEBIAN_SRC_DIR)/Testing/Data
	rm -rf $(DEBIAN_SRC_DIR)/Testing/Sikuli
	GZIP="--best --no-name" tar czf $(DEBIAN_SRC_TAR) $(DEBIAN_SRC_DIR)
	rm -rf $(DEBIAN_SRC_DIR)

=== debian/watch ===
version=3
http://sf.net/gofigure2/GoFigure2-v([\d\.]+)\.tar\.gz
